Package Graph

## Class Graph<T>

- java.lang.Object
- - Graph.Graph<T>

- Direct Known Subclasses:
    `OrientedGraph`, `UnorientedGraph`

      public abstract class Graph<T>
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected java.util.HashMap<T,​java.util.ArrayList<T>>` | `adjList` |
    `protected java.util.ArrayList<T>` | `vertices` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Graph()` | Constructeur

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract void` | `addEdge​(T u, T v)` | Ajout d'une arête/arc
    `void` | `addVertex​(T u)` | Ajout d'un sommet
    `boolean` | `hasEdge​(T u, T v)` | Teste si uv est une arête/un arc
    `boolean` | `hasVertex​(T u)` | Teste si u est un sommet
    `java.lang.String` | `toString()` | Conversion pour l'affichage

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### vertices

          protected java.util.ArrayList<T> vertices

    - #### adjList

          protected java.util.HashMap<T,​java.util.ArrayList<T>> adjList

  - ### Constructor Detail

    - #### Graph

          public Graph()

      Constructeur

  - ### Method Detail

    - #### hasVertex

          public boolean hasVertex​(T u)

      Teste si u est un sommet
      Parameters:
        `u` - un sommet
      Returns:
        boolean

    - #### hasEdge

          public boolean hasEdge​(T u,
                                 T v)

      Teste si uv est une arête/un arc
      Parameters:
        `u` - sommet
        `v` - sommet
      Returns:
        boolean uv est une arête/arc

    - #### addVertex

          public void addVertex​(T u)

      Ajout d'un sommet
      Parameters:
        `u` - sommet

    - #### addEdge

          public abstract void addEdge​(T u,
                                       T v)

      Ajout d'une arête/arc
      Parameters:
        `u` - sommet
        `v` - sommet

    - #### toString

          public java.lang.String toString()

      Conversion pour l'affichage
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        String